import { DocumentNode, GraphQLSchema } from "graphql";
/**
 * Generate typescript types for the schema and document specified.
 * @returns [string, string] Returns code generation for webpack
 * and for a declaration file. The former should be injected by the loader
 * during compilation and the latter can be emitted to a d.ts file
 * for IDE help.
 */
export default function codegen(schema: GraphQLSchema, document: DocumentNode): [string, string];
